<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.Initialization</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Int</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.C.Types</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Storable</span></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Alloc</span></span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Array</span></span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Utils</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">with</span></span><span class="hs-special">)</span><span>
</span><span id="line-11"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Memorable.html"><span class="hs-identifier">Memorable</span></a></span><span>
</span><span id="line-13"></span><span>
</span><span id="line-14"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDL.Raw.Types</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">SDL</span></span><span>
</span><span id="line-15"></span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-17"></span><span>
</span><span id="line-18"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#setInitWindow"><span class="hs-identifier hs-type">setInitWindow</span></a></span><span>
</span><span id="line-19"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190466"><span class="annot"><a href="#local-6989586621679190466"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-20"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190466"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-21"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint32"><span class="hs-identifier hs-type">GPU.Uint32</span></a></span><span> </span><span class="hs-comment">-- ^ windowID</span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190466"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-23"></span><span id="setInitWindow"><span class="annot"><span class="annottext">setInitWindow :: forall (m :: * -&gt; *). MonadIO m =&gt; Uint32 -&gt; m ()
</span><a href="SDL.GPU.Simple.Initialization.html#setInitWindow"><span class="hs-identifier hs-var hs-var">setInitWindow</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Uint32 -&gt; IO ()
</span><a href="SDL.GPU.C.Initialization.html#setInitWindow"><span class="hs-identifier hs-var">GPU.setInitWindow</span></a></span><span>
</span><span id="line-24"></span><span>
</span><span id="line-25"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#getInitWindow"><span class="hs-identifier hs-type">getInitWindow</span></a></span><span>
</span><span id="line-26"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190457"><span class="annot"><a href="#local-6989586621679190457"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-27"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190457"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190457"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint32"><span class="hs-identifier hs-type">GPU.Uint32</span></a></span><span>
</span><span id="line-29"></span><span id="getInitWindow"><span class="annot"><span class="annottext">getInitWindow :: forall (m :: * -&gt; *). MonadIO m =&gt; m Uint32
</span><a href="SDL.GPU.Simple.Initialization.html#getInitWindow"><span class="hs-identifier hs-var hs-var">getInitWindow</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *). MonadIO m =&gt; m Uint32
</span><a href="SDL.GPU.Simple.Initialization.html#getInitWindow"><span class="hs-identifier hs-var">getInitWindow</span></a></span><span>
</span><span id="line-30"></span><span>
</span><span id="line-31"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#getLinkedVersion"><span class="hs-identifier hs-type">getLinkedVersion</span></a></span><span>
</span><span id="line-32"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190455"><span class="annot"><a href="#local-6989586621679190455"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-33"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190455"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-34"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190455"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDL.Version</span></span><span>
</span><span id="line-35"></span><span id="getLinkedVersion"><span class="annot"><span class="annottext">getLinkedVersion :: forall (m :: * -&gt; *). MonadIO m =&gt; m Version
</span><a href="SDL.GPU.Simple.Initialization.html#getLinkedVersion"><span class="hs-identifier hs-var hs-var">getLinkedVersion</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; (Ptr a -&gt; IO ()) -&gt; IO a
</span><a href="Memorable.html#initMem"><span class="hs-identifier hs-var">initMem</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Version -&gt; IO ()
</span><a href="SDL.GPU.C.Initialization.html#getLinkedVersion"><span class="hs-identifier hs-var">GPU.getLinkedVersion</span></a></span><span>
</span><span id="line-36"></span><span>
</span><span id="line-37"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#setPreInitFlags"><span class="hs-identifier hs-type">setPreInitFlags</span></a></span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190447"><span class="annot"><a href="#local-6989586621679190447"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-39"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190447"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-40"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#InitFlagEnum"><span class="hs-identifier hs-type">GPU.InitFlagEnum</span></a></span><span> </span><span class="hs-comment">-- ^ GPU_flags</span><span>
</span><span id="line-41"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190447"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-42"></span><span id="setPreInitFlags"><span class="annot"><span class="annottext">setPreInitFlags :: forall (m :: * -&gt; *). MonadIO m =&gt; InitFlagEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.Initialization.html#setPreInitFlags"><span class="hs-identifier hs-var hs-var">setPreInitFlags</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">InitFlagEnum -&gt; IO ()
</span><a href="SDL.GPU.C.Initialization.html#setPreInitFlags"><span class="hs-identifier hs-var">GPU.setPreInitFlags</span></a></span><span>
</span><span id="line-43"></span><span>
</span><span id="line-44"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#getPreInitFlags"><span class="hs-identifier hs-type">getPreInitFlags</span></a></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190444"><span class="annot"><a href="#local-6989586621679190444"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-46"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190444"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190444"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#InitFlagEnum"><span class="hs-identifier hs-type">GPU.InitFlagEnum</span></a></span><span>
</span><span id="line-48"></span><span id="getPreInitFlags"><span class="annot"><span class="annottext">getPreInitFlags :: forall (m :: * -&gt; *). MonadIO m =&gt; m InitFlagEnum
</span><a href="SDL.GPU.Simple.Initialization.html#getPreInitFlags"><span class="hs-identifier hs-var hs-var">getPreInitFlags</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO InitFlagEnum
</span><a href="SDL.GPU.C.Initialization.html#getPreInitFlags"><span class="hs-identifier hs-var">GPU.getPreInitFlags</span></a></span><span>
</span><span id="line-49"></span><span>
</span><span id="line-50"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#setRequiredFeatures"><span class="hs-identifier hs-type">setRequiredFeatures</span></a></span><span>
</span><span id="line-51"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190442"><span class="annot"><a href="#local-6989586621679190442"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-52"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190442"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-53"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#FeatureEnum"><span class="hs-identifier hs-type">GPU.FeatureEnum</span></a></span><span> </span><span class="hs-comment">-- ^ GPU_flags</span><span>
</span><span id="line-54"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190442"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-55"></span><span id="setRequiredFeatures"><span class="annot"><span class="annottext">setRequiredFeatures :: forall (m :: * -&gt; *). MonadIO m =&gt; FeatureEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.Initialization.html#setRequiredFeatures"><span class="hs-identifier hs-var hs-var">setRequiredFeatures</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">FeatureEnum -&gt; IO ()
</span><a href="SDL.GPU.C.Initialization.html#setRequiredFeatures"><span class="hs-identifier hs-var">GPU.setRequiredFeatures</span></a></span><span>
</span><span id="line-56"></span><span>
</span><span id="line-57"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#getRequiredFeatures"><span class="hs-identifier hs-type">getRequiredFeatures</span></a></span><span>
</span><span id="line-58"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190439"><span class="annot"><a href="#local-6989586621679190439"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-59"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190439"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190439"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#FeatureEnum"><span class="hs-identifier hs-type">GPU.FeatureEnum</span></a></span><span>
</span><span id="line-61"></span><span id="getRequiredFeatures"><span class="annot"><span class="annottext">getRequiredFeatures :: forall (m :: * -&gt; *). MonadIO m =&gt; m FeatureEnum
</span><a href="SDL.GPU.Simple.Initialization.html#getRequiredFeatures"><span class="hs-identifier hs-var hs-var">getRequiredFeatures</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO FeatureEnum
</span><a href="SDL.GPU.C.Initialization.html#getRequiredFeatures"><span class="hs-identifier hs-var">GPU.getRequiredFeatures</span></a></span><span>
</span><span id="line-62"></span><span>
</span><span id="line-63"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#getDefaultRendererOrder"><span class="hs-identifier hs-type">getDefaultRendererOrder</span></a></span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190437"><span class="annot"><a href="#local-6989586621679190437"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-65"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190437"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190437"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-67"></span><span id="getDefaultRendererOrder"><span class="annot"><span class="annottext">getDefaultRendererOrder :: forall (m :: * -&gt; *). MonadIO m =&gt; m [RendererID]
</span><a href="SDL.GPU.Simple.Initialization.html#getDefaultRendererOrder"><span class="hs-identifier hs-var hs-var">getDefaultRendererOrder</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-68"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; Int -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">allocaArray</span></span><span> </span><span class="hs-glyph">@</span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="SDL.GPU.C.Initialization.html#rendererOrderMax"><span class="hs-identifier hs-var">GPU.rendererOrderMax</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190350"><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190350"><span class="hs-identifier hs-var">arr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-69"></span><span>    </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190348"><span class="annot"><span class="annottext">Ptr Int
</span><a href="#local-6989586621679190348"><span class="hs-identifier hs-var">psize</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-70"></span><span>      </span><span class="annot"><span class="annottext">Ptr Int -&gt; Ptr RendererID -&gt; IO ()
</span><a href="SDL.GPU.C.Initialization.html#getDefaultRendererOrder"><span class="hs-identifier hs-var">GPU.getDefaultRendererOrder</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Int
</span><a href="#local-6989586621679190348"><span class="hs-identifier hs-var">psize</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190350"><span class="hs-identifier hs-var">arr</span></a></span><span>
</span><span id="line-71"></span><span>      </span><span id="local-6989586621679190346"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679190346"><span class="hs-identifier hs-var">size</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Int
</span><a href="#local-6989586621679190348"><span class="hs-identifier hs-var">psize</span></a></span><span>
</span><span id="line-72"></span><span>      </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Int -&gt; Ptr a -&gt; IO [a]
</span><span class="hs-identifier hs-var">peekArray</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679190346"><span class="hs-identifier hs-var">size</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190350"><span class="hs-identifier hs-var">arr</span></a></span><span>
</span><span id="line-73"></span><span>
</span><span id="line-74"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#getRendererOrder"><span class="hs-identifier hs-type">getRendererOrder</span></a></span><span>
</span><span id="line-75"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190342"><span class="annot"><a href="#local-6989586621679190342"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-76"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190342"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-77"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190342"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-78"></span><span id="getRendererOrder"><span class="annot"><span class="annottext">getRendererOrder :: forall (m :: * -&gt; *). MonadIO m =&gt; m [RendererID]
</span><a href="SDL.GPU.Simple.Initialization.html#getRendererOrder"><span class="hs-identifier hs-var hs-var">getRendererOrder</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span>
</span><span id="line-79"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; Int -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">allocaArray</span></span><span> </span><span class="hs-glyph">@</span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="SDL.GPU.C.Initialization.html#rendererOrderMax"><span class="hs-identifier hs-var">GPU.rendererOrderMax</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190329"><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190329"><span class="hs-identifier hs-var">arr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-80"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190328"><span class="annot"><span class="annottext">Ptr Int
</span><a href="#local-6989586621679190328"><span class="hs-identifier hs-var">psize</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-81"></span><span>    </span><span class="annot"><span class="annottext">Ptr Int -&gt; Ptr RendererID -&gt; IO ()
</span><a href="SDL.GPU.C.Initialization.html#getRendererOrder"><span class="hs-identifier hs-var">GPU.getRendererOrder</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Int
</span><a href="#local-6989586621679190328"><span class="hs-identifier hs-var">psize</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190329"><span class="hs-identifier hs-var">arr</span></a></span><span>
</span><span id="line-82"></span><span>    </span><span id="local-6989586621679190326"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679190326"><span class="hs-identifier hs-var">size</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Int
</span><a href="#local-6989586621679190328"><span class="hs-identifier hs-var">psize</span></a></span><span>
</span><span id="line-83"></span><span>    </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Int -&gt; Ptr a -&gt; IO [a]
</span><span class="hs-identifier hs-var">peekArray</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">forall a b. (Integral a, Num b) =&gt; a -&gt; b
</span><span class="hs-identifier hs-var">fromIntegral</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679190326"><span class="hs-identifier hs-var">size</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190329"><span class="hs-identifier hs-var">arr</span></a></span><span>
</span><span id="line-84"></span><span>
</span><span id="line-85"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#setRendererOrder"><span class="hs-identifier hs-type">setRendererOrder</span></a></span><span>
</span><span id="line-86"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190425"><span class="annot"><a href="#local-6989586621679190425"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-87"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190425"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-comment">-- ^ order</span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190425"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-90"></span><span id="setRendererOrder"><span class="annot"><span class="annottext">setRendererOrder :: forall (m :: * -&gt; *). MonadIO m =&gt; [RendererID] -&gt; m ()
</span><a href="SDL.GPU.Simple.Initialization.html#setRendererOrder"><span class="hs-identifier hs-var hs-var">setRendererOrder</span></a></span></span><span> </span><span id="local-6989586621679190319"><span class="annot"><span class="annottext">[RendererID]
</span><a href="#local-6989586621679190319"><span class="hs-identifier hs-var">order</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; [a] -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">withArray</span></span><span> </span><span class="annot"><span class="annottext">[RendererID]
</span><a href="#local-6989586621679190319"><span class="hs-identifier hs-var">order</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Int -&gt; Ptr RendererID -&gt; IO ()
</span><a href="SDL.GPU.C.Initialization.html#setRendererOrder"><span class="hs-identifier hs-var">GPU.setRendererOrder</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; Int
</span><span class="hs-identifier hs-var">length</span></span><span> </span><span class="annot"><span class="annottext">[RendererID]
</span><a href="#local-6989586621679190319"><span class="hs-identifier hs-var">order</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-91"></span><span>
</span><span id="line-92"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#init"><span class="hs-identifier hs-type">init</span></a></span><span>
</span><span id="line-93"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190419"><span class="annot"><a href="#local-6989586621679190419"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-94"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190419"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-95"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Word16</span></span><span> </span><span class="hs-comment">-- ^ w</span><span>
</span><span id="line-96"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Word16</span></span><span> </span><span class="hs-comment">-- ^ h</span><span>
</span><span id="line-97"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#WindowFlagEnum"><span class="hs-identifier hs-type">GPU.WindowFlagEnum</span></a></span><span>
</span><span id="line-98"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190419"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-99"></span><span id="init"><span class="annot"><span class="annottext">init :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Word16 -&gt; Word16 -&gt; WindowFlagEnum -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.Initialization.html#init"><span class="hs-identifier hs-var hs-var">init</span></a></span></span><span> </span><span id="local-6989586621679190312"><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190312"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679190311"><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190311"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span id="local-6989586621679190310"><span class="annot"><span class="annottext">WindowFlagEnum
</span><a href="#local-6989586621679190310"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Word16 -&gt; Word16 -&gt; WindowFlagEnum -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.Initialization.html#init"><span class="hs-identifier hs-var">GPU.init</span></a></span><span> </span><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190312"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190311"><span class="hs-identifier hs-var">h</span></a></span><span> </span><span class="annot"><span class="annottext">WindowFlagEnum
</span><a href="#local-6989586621679190310"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-100"></span><span>
</span><span id="line-101"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#initRenderer"><span class="hs-identifier hs-type">initRenderer</span></a></span><span>
</span><span id="line-102"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190415"><span class="annot"><a href="#local-6989586621679190415"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-103"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190415"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-104"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererEnum"><span class="hs-identifier hs-type">GPU.RendererEnum</span></a></span><span>
</span><span id="line-105"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Word16</span></span><span> </span><span class="hs-comment">-- ^ w</span><span>
</span><span id="line-106"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Word16</span></span><span> </span><span class="hs-comment">-- ^ h</span><span>
</span><span id="line-107"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#WindowFlagEnum"><span class="hs-identifier hs-type">GPU.WindowFlagEnum</span></a></span><span>
</span><span id="line-108"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190415"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-109"></span><span id="initRenderer"><span class="annot"><span class="annottext">initRenderer :: forall (m :: * -&gt; *).
MonadIO m =&gt;
RendererEnum
-&gt; Word16 -&gt; Word16 -&gt; WindowFlagEnum -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.Initialization.html#initRenderer"><span class="hs-identifier hs-var hs-var">initRenderer</span></a></span></span><span> </span><span id="local-6989586621679190305"><span class="annot"><span class="annottext">RendererEnum
</span><a href="#local-6989586621679190305"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span id="local-6989586621679190304"><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190304"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679190303"><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190303"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span id="local-6989586621679190302"><span class="annot"><span class="annottext">WindowFlagEnum
</span><a href="#local-6989586621679190302"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">RendererEnum
-&gt; Word16 -&gt; Word16 -&gt; WindowFlagEnum -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.Initialization.html#initRenderer"><span class="hs-identifier hs-var">GPU.initRenderer</span></a></span><span> </span><span class="annot"><span class="annottext">RendererEnum
</span><a href="#local-6989586621679190305"><span class="hs-identifier hs-var">r</span></a></span><span> </span><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190304"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190303"><span class="hs-identifier hs-var">h</span></a></span><span> </span><span class="annot"><span class="annottext">WindowFlagEnum
</span><a href="#local-6989586621679190302"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-110"></span><span>
</span><span id="line-111"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#initRendererByID"><span class="hs-identifier hs-type">initRendererByID</span></a></span><span>
</span><span id="line-112"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190412"><span class="annot"><a href="#local-6989586621679190412"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-113"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190412"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-114"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span>
</span><span id="line-115"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Word16</span></span><span> </span><span class="hs-comment">-- ^ w</span><span>
</span><span id="line-116"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Word16</span></span><span> </span><span class="hs-comment">-- ^ h</span><span>
</span><span id="line-117"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#WindowFlagEnum"><span class="hs-identifier hs-type">GPU.WindowFlagEnum</span></a></span><span>
</span><span id="line-118"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190412"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-119"></span><span id="initRendererByID"><span class="annot"><span class="annottext">initRendererByID :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr RendererID
-&gt; Word16 -&gt; Word16 -&gt; WindowFlagEnum -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.Initialization.html#initRendererByID"><span class="hs-identifier hs-var hs-var">initRendererByID</span></a></span></span><span> </span><span id="local-6989586621679190297"><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190297"><span class="hs-identifier hs-var">rid</span></a></span></span><span> </span><span id="local-6989586621679190296"><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190296"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679190295"><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190295"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span id="local-6989586621679190294"><span class="annot"><span class="annottext">WindowFlagEnum
</span><a href="#local-6989586621679190294"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID
-&gt; Word16 -&gt; Word16 -&gt; WindowFlagEnum -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.Initialization.html#initRendererByID"><span class="hs-identifier hs-var">GPU.initRendererByID</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID
</span><a href="#local-6989586621679190297"><span class="hs-identifier hs-var">rid</span></a></span><span> </span><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190296"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Word16
</span><a href="#local-6989586621679190295"><span class="hs-identifier hs-var">h</span></a></span><span> </span><span class="annot"><span class="annottext">WindowFlagEnum
</span><a href="#local-6989586621679190294"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-120"></span><span>
</span><span id="line-121"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#isFeatureEnabled"><span class="hs-identifier hs-type">isFeatureEnabled</span></a></span><span>
</span><span id="line-122"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190410"><span class="annot"><a href="#local-6989586621679190410"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-123"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190410"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-124"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#FeatureEnum"><span class="hs-identifier hs-type">GPU.FeatureEnum</span></a></span><span>
</span><span id="line-125"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190410"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-126"></span><span id="isFeatureEnabled"><span class="annot"><span class="annottext">isFeatureEnabled :: forall (m :: * -&gt; *). MonadIO m =&gt; FeatureEnum -&gt; m Bool
</span><a href="SDL.GPU.Simple.Initialization.html#isFeatureEnabled"><span class="hs-identifier hs-var hs-var">isFeatureEnabled</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#isTrue"><span class="hs-identifier hs-var">GPU.isTrue</span></a></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">FeatureEnum -&gt; IO Bool
</span><a href="SDL.GPU.C.Initialization.html#isFeatureEnabled"><span class="hs-identifier hs-var">GPU.isFeatureEnabled</span></a></span><span>
</span><span id="line-127"></span><span>
</span><span id="line-128"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#closeCurrentRenderer"><span class="hs-identifier hs-type">closeCurrentRenderer</span></a></span><span>
</span><span id="line-129"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190402"><span class="annot"><a href="#local-6989586621679190402"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-130"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190402"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-131"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190402"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-132"></span><span id="closeCurrentRenderer"><span class="annot"><span class="annottext">closeCurrentRenderer :: forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Initialization.html#closeCurrentRenderer"><span class="hs-identifier hs-var hs-var">closeCurrentRenderer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO ()
</span><a href="SDL.GPU.C.Initialization.html#closeCurrentRenderer"><span class="hs-identifier hs-var">GPU.closeCurrentRenderer</span></a></span><span>
</span><span id="line-133"></span><span>
</span><span id="line-134"></span><span class="annot"><a href="SDL.GPU.Simple.Initialization.html#quit"><span class="hs-identifier hs-type">quit</span></a></span><span>
</span><span id="line-135"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190275"><span class="annot"><a href="#local-6989586621679190275"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-136"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190275"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-137"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190275"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-138"></span><span id="quit"><span class="annot"><span class="annottext">quit :: forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.Initialization.html#quit"><span class="hs-identifier hs-var hs-var">quit</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO ()
</span><a href="SDL.GPU.C.Initialization.html#quit"><span class="hs-identifier hs-var">GPU.quit</span></a></span><span>
</span><span id="line-139"></span></pre></body></html>